VERSION 5.00
Begin VB.UserControl Fader 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ForeColor       =   &H00FFFFFF&
   Picture         =   "Fader.ctx":0000
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   ToolboxBitmap   =   "Fader.ctx":1C62
   Begin VB.Image Image1 
      Appearance      =   0  'Flat
      Height          =   300
      Left            =   75
      Picture         =   "Fader.ctx":1F74
      Top             =   0
      Width           =   150
   End
   Begin VB.Shape shFocus 
      BorderStyle     =   0  'Transparent
      DrawMode        =   7  'Invert
      FillColor       =   &H0080F0F0&
      FillStyle       =   0  'Solid
      Height          =   135
      Left            =   0
      Shape           =   4  'Rounded Rectangle
      Top             =   90
      Visible         =   0   'False
      Width           =   1800
   End
End
Attribute VB_Name = "Fader"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim pMax As Integer, pValue As Integer
Public Event Change()

Private Sub Image1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  UserControl_MouseDown Button, Shift, X / Screen.TwipsPerPixelX + Image1.Left, Y
End Sub

Private Sub Image1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  UserControl_MouseMove Button, Shift, X / Screen.TwipsPerPixelX + Image1.Left, Y
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
  Select Case KeyCode
    Case 37: Value = Value - 1
    Case 39: Value = Value + 1
    Case 38: SendKeys "+{tab}"
    Case 40: SendKeys "{tab}"
  End Select
End Sub

Private Sub UserControl_GotFocus()
  shFocus.Visible = True
End Sub

Private Sub UserControl_LostFocus()
  shFocus.Visible = False
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Dim v As Integer
  If Button <> 1 Then Exit Sub
  v = X - 10
  If v < 0 Then v = 0
  If v > 100 Then v = 100
  Value = Max * v / 100
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Static xx As Integer, yy As Integer
  If (xx = Int(X)) And (yy = Int(Y)) Then Exit Sub
  xx = Int(X): yy = Int(Y)
  UserControl.SetFocus
  UserControl_MouseDown Button, Shift, X, Y
End Sub

Private Sub UserControl_Resize()
  UserControl.Width = 120 * Screen.TwipsPerPixelX
  UserControl.Height = 20 * Screen.TwipsPerPixelY
  shFocus.Left = 0
  shFocus.Top = 6
  shFocus.Width = 120
  shFocus.Height = 9
  If pMax < 1 Then pMax = 1
End Sub

Public Property Get Value() As Integer
  Value = pValue
End Property

Public Property Let Value(ByVal v As Integer)
  If pValue = v Then Exit Property
  pValue = v
  If pValue < 0 Then pValue = 0
  If pValue > pMax Then pValue = pMax
  Image1.Left = 5! + 100! * pValue / pMax
  RaiseEvent Change
End Property

Public Property Get Max() As Integer
  Max = pMax
End Property

Public Property Let Max(ByVal m As Integer)
  Dim n As Integer, p As Integer
  pMax = m
  If pMax < 1 Then pMax = 1
  If Value > Max Then Value = Max
  UserControl.Cls
  If pMax < 33 Then
    For n = 0 To Max
      p = 9! + 100! * n / pMax
      UserControl.Line (p, 1)-(p, 5), &H0
      UserControl.Line (p, 15)-(p, 19), &H0
      UserControl.Line (p + 1, 1)-(p + 1, 5), &HFFFFFF
      UserControl.Line (p + 1, 15)-(p + 1, 19), &HFFFFFF
    Next n
  End If
End Property

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  Max = PropBag.ReadProperty("Max", Max)
  Value = PropBag.ReadProperty("Value", Value)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  PropBag.WriteProperty "Max", Max
  PropBag.WriteProperty "Value", Value
End Sub
